#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Ag;
use FDN::Adsl::Basic;

sub invalide {
	my ( $info ) = @_;
	$info //= '';
	my $page = '<div style="width: 600px"><div class="error">Invalide ('.$info.')</div></div>';
	eject_page_adh($page);
	exit(0);
}

prepare_page_adh(only_for_adh => 1);

my $page = '<table style="max-width: 600px">'."\n<tr><td><h2>Convocations aux assembles gnrales</h2></td></tr></table>\n\n";

my $annee = $vars->{'annee'};
if ( $annee !~ /^20\d\d$/ ) {
	invalide("char");
}

my $cfg = Config_Section('adsl/adhs/ag.cfg', 'ag-'.$annee);
if ( ! $cfg ) {
	invalide("config");
}

if ( $cfg->{'status'} =~ /^(new|old)/ ) {
	invalide("status");
}
my $date = $cfg->{'date'};

my $cnt = {
	pdf => 0,
	oui => 0,
	procu => 0
};

my $present = '<div style="width: 600px">'."\n<h2>Liste des personnes qui seront prsentes pour l'AG $annee</h2>\n\n";
$present .= "<table>\n";
$present .= "<tr><th>Qui...</th><th>droit de vote...</th></tr>\n";

my $page = '<div style="width: 600px">'."\n<h2>Liste des procurations pour l'AG $annee</h2>\n\n";
my $exercice = $annee - 1;
$page .= "<p>Assemble gnrale portant sur l'exercice $exercice</p>\n";

$page .= "<table>\n";
$page .= "<tr><th>Qui...</th><th>droit de vote...</th><th>est reprsent&middot;e par...</th></td>\n";
my $convs = [ tous_convocation() ];
for my $conv ( @$convs ) {
	my $cid = $conv->{'CLIENT_ID'};
	my ( $form, $pres, $proc ) = split_convocation($cid, $annee);
	if ( $form eq 'pdf' ) {
		$cnt->{'pdf'}++;
	}
	my $client = client_par_id($cid);
	my $name = $client->{'CLIENT_NOM'}.' ('.$client->{'CLIENT_NUMADH'}.')';
	my $vote = droit_de_vote($cid, $date, 'vote');
	$vote = $vote ? 'Oui' : 'Non';
	if ( ! $proc ) {
		if ( $pres eq 'oui' ) {
			$present .= "<tr><td>$name</td><td>$vote</td></tr>\n";
			$cnt->{'oui'}++;
		}
		next;
	}
	my $repre = affiche_convocation_procuration($cid, $annee);
	my $numadh = numadh_convocation_procuration($cid, $annee);
	$cnt->{$numadh} //= 0;


	$page .= "<tr><td>$name</td><td>$vote</td><td>$repre</td></tr>\n";
	$cnt->{'procu'}++;
	$cnt->{$numadh}++;
}

if ( $cfg->{'@procu'} ) {
	for my $manuelle ( @{$cfg->{'@procu'}} ) {
		next if $manuelle !~ /(\d+),(.*)$/;
		my ( $num, $nom ) = ( $1, $2 );
		my $client = client_par_numadh($num);
		if ( ! $client ) {
			$page .= '<tr><td colspan="3">PROCURATION MANUELLE INVALIDE</td></tr>'."\n";
			next;
		}
		my $numadh = $client->{'CLIENT_NUMADH'};
		my $cid = $client->{'CLIENT_ID'};
		my $name = $client->{'CLIENT_NOM'}.' ('.$numadh.')';
		my $vote = droit_de_vote($cid, $date, 'vote');
		$vote = $vote ? 'Oui' : 'Non';
		$page .= "<tr><td>$name</td><td>$vote</td><td>$nom (procuration manuelle auprs du bureau)</td>\n";
		$cnt->{'procu'}++;
		$cnt->{$numadh} //= 0;
		$cnt->{$numadh}++;
	}
}
$page .= "</table>\n";
$page .= '</div>';

$present .= "</table>\n";
$present .= "</dir>\n";

my $for_me;
my $client = client_par_id($sess->{'content'}->{'cid'});
my $numadh = $client->{'CLIENT_NUMADH'};
if ( exists $cnt->{$numadh}) {
	$for_me = " (dont $cnt->{$numadh} pour moi)";
}

my $compte = '<div style="width: 600px">'."\n<h2>D&eacute;comptes</h2>\n\n";
$compte.= "<table>\n";
$compte.= "<tr><th>PDF</th><td>$cnt->{'pdf'}</td></tr>\n";
$compte.= "<tr><th>Pr&eacute;sents</th><td>$cnt->{'oui'}</td></tr>\n";
$compte.= "<tr><th>Procurations</th><td>$cnt->{'procu'}$for_me</td></tr>\n";
$compte.= "</table>\n";
$compte.= "</div>\n";


eject_page_adh($present.$page);


