#!/usr/bin/perl

use strict;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Utils;
use FDN::Adsl::Ldap;

prepare_page_adh();
my $page = '';

my $cfg = 'adsl/adhs/adh.cfg';
my $form = form_read ($cfg, 'modpasswd');

my $id = $vars->{aid};

if ( $vars->{do} ne 'yes' ) {

    if ( ! defined $form ) {
        $page .= "<p>Echec au chargement du formulaire</p>";
        eject_page_adh($page);
        exit(0);
    }

    my $vars = {
        'passwdchange' => "",
	'passwdchange_verif' => "",
	'sess' => $sess->{'name'},
        'aid' => $id,
    };

    $page .= "<div style=\"width:300px\">".affiche_form($form, $vars)."</div>";

    eject_page_adh($page);
    exit(0);
}

if ( ! check_transition($form,$vars) ) {
    info 'Formulaire invalide';
    $page .= affiche_form($form,$vars);
    eject_page_adh($page);
    exit(0);
}

prepare_page_adh();

if ( $vars->{'passwdchange'} eq $vars->{'passwdchange_verif'} ) {
	set_adhaccess_passwd ( $id, $vars->{'passwdchange'});
	my $adhaccess = adhaccess_par_id($id);
	ldap_update_client($adhaccess->{CLIENT_ID});
	$page .= "<p>Votre mot de passe a t modifi.<p>";
}else {
        $page .= "<div class='error'>Les mots de pass ne correspondent pas.</div>";	
}

eject_page_adh($page);
exit(0);
