#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Common::Logger;
use FDN::Common::Utils;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use FDN::Sql::Workflow::Run;


prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};
my $id = $vars->{'id'};
my $don = don_par_id($id);

if ( $don->{'CLIENT_ID'} ne $cid ) {
	eject_page_adh('<p>Petit curieux va !</p>');
	exit(0);
}

if ( $vars->{'confirm'} ne 'ok' ) {
	my $montant = $don->{'DON_MONTANT'};
	$montant =~ s/(\d{2})$/,$1/;
	$page = '<h2>Rsiliation du don '.$don->{DON_TYPE}.' de '.$montant.'&euro;</h2>'.
		'<p>Si vous confirmez cette rsiliation, elle sera effective tout de suite. Il est encore temps de faire demi-tour.</p>'.
		'<p><a href="/adherents/adh-resdon.cgi?id='.$id.'&confirm=ok&sess=%%sess%%">Confirmation</a></p>';
	eject_page_adh($page);
	exit(0);
}


new_info_client($id,'inline','Resiliation don','Resiliation par l adherent en ligne.');
if ( $don->{'DON_STATE'} eq 'new' ) {
	set_don_state($id,'cancel');
	$page = '<p>Ce don a t annul.</p>';
	eject_page_adh($page);
	exit(0);
}

if ( $don->{'DON_STATE'} eq 'cancel' ) {
	$page = '<p>Ce don est dj annul.</p>';
	eject_page_adh($page);
	exit(0);
}

if ( $don->{'DON_STATE'} eq 'done' ) {
	$page = '<p>Ce don est dj factur.</p>';
	eject_page_adh($page);
	exit(0);
}

if ( $don->{'DON_STATE'} eq 'ended' ) {
	$page = '<p>Ce don est dj rsili.</p>';
	eject_page_adh($page);
	exit(0);
}

if ( $don->{'DON_TYPE'} eq 'ponctuel' ) {
	set_don_state($id, 'cancel');
	$page = "<p>Ce don est annul.</p>"; 
} else {
	set_don_fin($id, get_timestamp());
	$page = "<p>Ce don est rsili  la date d'aujourd'hui.</p>"; 
}

eject_page_adh($page);
exit(0);


