#!/usr/bin/perl

use strict;
use FDN::Web::Array;
use FDN::Web::Forms;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Common::Config;
use FDN::Sql::Workflow::Basic;
use FDN::Adsl::Adhs;
use FDN::Adsl::SelL;
use FDN::Adsl::Basic;
use FDN::Adsl::Infos;
use Data::Dumper;

prepare_page_adh();
my $page = '';
my $cid = $sess->{content}->{cid};
my $lid = $vars->{'lid'};

my $ligne = ligne_par_id($lid);
if ( ! defined $ligne ) {
	$page = "<p>Il ne faut pas tricher</p>";
	goto EJECT;
}

if ( $ligne->{'CLIENT_ID'} ne $cid ) {
	$page = "<p>Petit&middot;e curieux&middot;se va</p>";
	goto EJECT;
}

if ($vars->{'type'} ne '0' and
    $vars->{'type'} ne '1' and
    $vars->{'type'} ne '2' and
    $vars->{'type'} ne '3' and
    $vars->{'type'} ne '4') {
	$page = "<p>Type $vars->{'type'} invalide</p>";
	goto EJECT;
}

my $client = client_par_id($cid);

if ( $ligne->{'LIGNE_OPT'} !~ 'Liazo' ) {
	$page .= "<p>On ne sait pas tester une ligne qui n'est pas chez Liazo.</p>";
	goto EJECT;
}

my $tel = $ligne->{'LIGNE_TEL'};
my $pr = get_ligne_commande($lid);
my $service = get_commande_serviceref($pr);
my $res = test_adsl($service, $vars->{'type'});

if (not defined $res) {
	$page .= "<p>Test chou compltement...</p>";
	goto EJECT;
}
#$page .= Dumper $res;

$page .= "<h1>Test numro $res->{'id'} pour la ligne $tel</h1>";

my $raw = $res->{'raw_result'};
for my $result ( @$raw ) {
	my $dir = Config_Key('adsl/global.cfg','dirs','htmltpl');
	$page .= Rewrite_Props('adsl/props.tbl', 'test-adsl', $dir.'/arr1.tpl', $result, "");
}

EJECT:
eject_page_adh($page);
