#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Common::Logger;
use FDN::Common::Modules;
use FDN::Web::Array;
use FDN::Web::Forms;
use FDN::Adsl::Adhs;
use FDN::Adsl::Basic;
use FDN::Adsl::Ag;
use FDN::Adsl::Utils;

sub invalide {
	my ( $info ) = @_;
	$info //= '';
	my $page = '<div style="width: 600px"><div class="error">Invalide ('.$info.')</div></div>';
	eject_page_adh($page);
	exit(0);
}

prepare_page_adh(only_for_adh => 1);

my $page = "";

my $vote = $vars->{'vote'};
if ( $vote !~ /^[a-z0-9_]*$/ ) {
	invalide("char");
}

my $gcfg = Load_Config('adsl/adhs/vote.cfg');
if ( ! $gcfg ) {
	invalide("config");
}

my $cfg = $gcfg->{"vote-$vote"};
if ( ! $cfg ) {
	invalide("vote $vote");
}

if ( $cfg->{'status'} !~ /^open$/ ) {
	invalide("status");
}

my $form = form_read ( 'adsl/adhs/adh.cfg', 'voteedit' );

my $cid = $sess->{content}->{cid};
my $v = vote_par_client_id($cid);
if ( ! $v ) {
	invalide();
}
my $levote = get_vote($cid, $vote);
my @lesvotes = split /;/,$levote;

if ( $vars->{'do'} ne 'yes' ) {
	if ( ! defined $form ) {
		invalide("form");
		exit(0);
	}

	conduse('FDN::Web::Forms','dynamics');

	my $texte = $cfg->{'texte'};
	$form->{byname}->{votequestion}->{content} = $texte;

	my $votenum = 0;
	for my $fldname ( @{$cfg->{'@fields'}} ) {
		# pré-remplir avec ce qui a été choisi précédemment
		$vars->{$fldname} = $lesvotes[$votenum];

		my $svblanc = form_new_selval($gcfg, 'blanc');
		ajoute_champ_config($form, 'adsl/adhs/vote.cfg', 'voteedit', $fldname);
		form_add_selval($form->{byname}->{$fldname},$svblanc);

		$votenum += 1;
	}
		
	$page .= "<div style=\"width:300px\">".affiche_form($form,$vars)."</div>";
	eject_page_adh($page);
	exit(0);
}

if ( ! check_transition($form,$vars) ) {
        info 'Formulaire invalide';
        $page .= affiche_form($form,$vars);
        eject_page_adh($page);
        exit(0);
}

my $levote = '';
my $premier = 1;
for my $fldname ( @{$cfg->{'@fields'}} ) {
	my $choix = $vars->{$fldname};

	if ( $choix !~ /^[a-z0-9_-]*$/ ) {
		invalide("char");
	}
	print STDERR "Je change pour $vote -> $choix\n";

	if ( $premier ) {
		$premier = 0;
	} else {
		$levote .= ';';
	}
	$levote .= $choix;
}

set_vote($v->{VOTE_ID}, $vote, $levote);

print "Location: adh-vote.cgi?sess=".$vars->{'sess'}."\n\n";

