#!/usr/bin/perl

use strict;
use FDN::Common::Config;
use FDN::Web::Array;
use FDN::Adsl::Adhs;
use FDN::Adsl::Ag;
use FDN::Adsl::Basic;
use List::Util qw(shuffle);

sub invalide {
	my ( $info ) = @_;
	$info //= '';
	my $page = '<div style="width: 600px"><div class="error">Invalide ('.$info.')</div></div>';
	eject_page_adh($page);
	exit(0);
}

prepare_page_adh(only_for_adh => 1);

my $page;
my $pagedetails;

my $vote = $vars->{'vote'};
if ( $vote !~ /^[a-z0-9_]*$/ ) {
	invalide("char");
}

my $gcfg = Load_Config('adsl/adhs/vote.cfg');
if ( ! $gcfg ) {
	invalide("config");
}

my $cfg = $gcfg->{"vote-$vote"};
if ( ! $cfg ) {
	invalide("vote $vote");
}

if ( $cfg->{'status'} !~ /^old$/ ) {
	invalide("status");
}
my $date = $cfg->{'date'};

$page = '<div style="width: 600px">'."\n<h1>Rsultats des votes pour $vote</h1>\n\n";
$page .= '<a href=adh-vote.cgi?sess=%%sess%%>Retour  la liste des votes</a>';
$pagedetails = '<div style="width: 600px">'."\n<h1>Dtail des votes pour $vote</h1>\n\n";

my $votes = [ tous_vote() ];

my $votenum = 0;
for my $fldname ( @{$cfg->{'@fields'}} ) {
	my $field = $gcfg->{'field-'.$fldname};
	my $label = $field->{label};

	$pagedetails .= '<div style="width: 600px">';
	$pagedetails .= "<h2>$label</h2>\n";

	# On compte pour chaque choix combien de bulletin l'ont
	my $compte = {};
	for my $value (@{$field->{'@values'}}) {
		$compte->{$value} = 0;
	}
	$compte->{blanc} = 0;
	$compte->{invalide} = 0;

	my @bulletins;
	my @emargements;

	# On compte pour chaque bulletin
	for my $v ( @$votes ) {
		my $cid = $v->{'CLIENT_ID'};
		my $client = client_par_id($cid);
		my $name = $client->{'CLIENT_NOM'}.' ('.$client->{'CLIENT_NUMADH'}.')';
		my $droit = droit_de_vote($cid, $date, 'vote');
		my $res;

		if ($droit) {
			my $levote = get_vote($cid, $vote);
			next if (!defined $levote or $levote eq '');

			my @lesvotes = split /;/,$levote;
			my $choix = $lesvotes[$votenum];
			my $sv = $gcfg->{"selval-$choix"};
			if (defined $sv) {
				$res = $sv->{label};

				if (!defined $compte->{$choix}) {
					$compte->{$choix} = 1;
				} else {
					$compte->{$choix} += 1;
				}
			} else {
				$res = "Bulletin '$choix' invalide !";
				$compte->{invalide} += 1;
			}
		} else {
			# pas le droit de vote
			next;
		}

		if ($cfg->{secret} eq 'false') {
			push(@bulletins, {'ID'=>$name, 'RES'=>$res});
		} else {
			push(@emargements, $name);
			my $hash = get_vote_hash($cid, $vote);
			push(@bulletins, {'ID'=>$hash, 'RES'=>$res});
		}
	}

	if ($cfg->{secret} ne 'false') {
		@emargements = sort @emargements;

		$pagedetails .= "<h4>votants</h4>\n";
		$pagedetails .= "<table>\n";
		for my $emargement ( @emargements ) {
			$pagedetails .= "<tr><td>".$emargement."</td></tr>\n";
		}
		$pagedetails .= "</table>\n";

		$pagedetails .= "<h4>bulletins</h4>\n";
	}

	# Trier par ordre de hash pour mlanger les bulletins
	@bulletins = sort { $a->{ID} cmp $b->{ID} } @bulletins;
	$pagedetails .= "<table>\n";
	for my $bulletin ( @bulletins ) {
		$pagedetails .= "<tr><td>".$bulletin->{ID}."</td><td>".$bulletin->{RES}."</td></tr>\n";
	}
	$pagedetails .= "</table>\n";

	$page .= '<div style="width: 600px">';
	$page .= "<h2>$label</h2>\n";

	$page .= "<table>\n";

	# On fait un rsum
	my $total;
	for my $choix (@{$field->{'@values'}}) {
		my $sv = $gcfg->{"selval-$choix"};
		$page .= "<tr><td>$sv->{label}</td><td>$compte->{$choix}</td></tr>";
		$total += $compte->{$choix};
	}

	$page .= "<tr><td>Bulletins blancs</td><td>$compte->{blanc}</td></tr>";
	$total += $compte->{blanc};

	if ($compte->{invalide} > 0) {
		$page .= "<tr><td>Bulletins invalides</td><td>$compte->{invalide}</td></tr>";
		$total += $compte->{invalide};
	}

	$page .= "<tr><td>Total</td><td>$total</td></tr>";

	$page .= "</table>\n";
	$page .= '</div>';

	$votenum += 1;
}

eject_page_adh($page.$pagedetails);


