#!/usr/bin/perl

use strict;
use CGI;
use DateTime;
use FDN::Adsl::Stats;
use FDN::Adsl::Utils;
use FDN::Adsl::Basic;

use Data::Dumper;
use List::MoreUtils qw(any);

my $cgi = new CGI;
my $vars = $cgi->Vars;

print "Content-Type: application/json; charset=UTF-8\n\n";

my $now = DateTime->now;
my $stats = retrieve_stats($now->ymd);

print '{
	"name": "French Data Network",
	"shortname": "FDN",
	"description": "Fournisseur d\'Accès à Internet associatif depuis 1992",
	"logoURL": "https://www.fdn.fr/wp-content/uploads/logo-fdn.png",
	"website": "https://www.fdn.fr/",
	"otherWebsites": {
		"blog FDN": "http://blog.fdn.fr/",
		"Wiki": "https://git.fdn.fr/fdn-public/wiki/-/blob/master/README.md"
	},
	"email": "buro@fdn.fr",
	"mainMailingList": "ag@fdn.fr",
	"creationDate": "1992-06-01",
	"ffdnMemberSince": "2011-03-12",
	"progressStatus": 7,
';

print "	\"memberCount\": $stats->{nbadh}->{count},\n";
print "	\"subscriberCount\": $stats->{nbadh_abonne}->{count},\n";
print '	"chatrooms" : [ "irc://irc.geeknode.net/#fdn" ],
	"registeredOffice": {
		"street-address": "27, rue de Cassiopée",
		"postal-code": "56890",
		"locality": "SAINT-AVÉ",
		"country-name": "France"
	},
	"coordinates": {
		"latitude": 47.68559,
		"longitude": -2.74719
	},
	"coveredAreas": [{"technologies": ["ftth", "dsl", "vpn"], "name": "France entière"}],
	"version": 0.1
}
';
